import React, { useContext, useState} from "react";
import { Redirect } from "react-router-dom";
import { IOCDeployDialog } from "./IOCDeployDialog";
import { notificationContext } from "../../components/common/notification/Notifications";

// Process component
export function DeployIOC({ open, setOpen, submitCallback, hook, hasActiveDeployment, init={}}) {
  function onError(message) {
    setError(message);
  }

  const [deployment, action] = hook(onError);
  const [error, setError] = useState();
  const {watchDeployment} = useContext(notificationContext);

  if (!deployment) {
    return (<IOCDeployDialog open={open} setOpen={setOpen} submitCallback={action} init={init} 
              hasActiveDeployment={hasActiveDeployment} error={error} resetError={() => setError(null)}/>);
  }
  else {
    submitCallback(); // This works but throws a warning because I am changing state in the parent while the child is rerendering. Not sure yet how to fix.
    watchDeployment(deployment.id);
    return (<Redirect to={`/deployments/${deployment.id}`} push />);
  }
}