import { useEffect } from "react";
import { useTagsAndCommitIds, useCSentryHost } from "../../api/SwaggerApi";

function onError(message) {
  console.warn(message);
}

export function DeploymentDetailFetcher({ deployment, index, setDeployments }) {
  const [tagOrCommitId, getTagOrCommitId] = useTagsAndCommitIds(onError);
  const [host, getHost] = useCSentryHost(onError);

  useEffect(() => {
    getTagOrCommitId(deployment.gitProjectId, deployment.sourceVersion);
    getHost(deployment.host.externalHostId);
  }, [deployment, getTagOrCommitId, getHost])

  useEffect(() => {
    setDeployments((deployments) => {
      deployments[index].sourceVersionShort = tagOrCommitId?.length === 1 ? tagOrCommitId[0].shortReference : deployments[index].sourceVersionShort;
      deployments[index].host = host ?? deployments[index].host;
      return [...deployments];
    });
  }, [index, setDeployments, tagOrCommitId, host])

  return null;
}