import { useCallback } from "react";
import { useHistory } from "react-router-dom";

export function useRedirect() {
  const history = useHistory();
  const redirect = useCallback((destination, state, replace=false) => {
    const method = replace ? history.replace : history.push;
    method(destination, { ...state, from: history.location.pathname });
  }, [history.location.pathname, history.push, history.replace])
  return redirect;
}