import React, {useState} from 'react';
import { IOCDetailsView } from "./IOCDetailsView";
import { LinearProgress } from '@material-ui/core';
import NotFound from '../../components/navigation/NotFound';
import {onFetchEntityError} from '../../components/common/Helper';
import { useIOC } from "../../api/SwaggerApi";

export function IOCDetailsContainer({ id }) {
  const [notFoundError, setNotFoundError] = useState();
  const [ioc, getIOC, /*reset*/, loading] = useIOC(id, (m, s) => onFetchEntityError(m, s, setNotFoundError));

  return (
    <>
      {
        notFoundError ? <NotFound message={notFoundError}/> :
          ioc ?
            <IOCDetailsView ioc={ioc} getIOC={getIOC} loading={loading}/>
            :
            <LinearProgress color="primary" />
      }
    </>
  );
}